// https://forex-station.com/viewtopic.php?p=1295478806#p1295478806 //button code1
// https://forex-station.com/viewtopic.php?p=1295478883#p1295478883 //button code2
// not for sale, rent, nor auction
// July 26th, 2020
// May 27th, 2023, v. 1.05; adding Golden Fibo color
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Define the Variables to use.....                                 |
//+------------------------------------------------------------------+
extern string             note1                 = "Fibonacci colors";
extern bool               DisplayUpperFibo      = true;
extern color              UpperFiboColor        = clrDarkGreen; //clrDarkGray
extern ENUM_LINE_STYLE    UpperFiboStyle        = STYLE_DASH;
extern int                UpperFiboWidth        = 1;
extern string             note2                 = "------------------------------";
extern bool               DisplayMainFibo       = true;
extern color              MainFiboColor         = clrGray;
extern color              GoldenFiboColor       = clrDarkGoldenrod;
extern ENUM_LINE_STYLE    MainFiboStyle         = STYLE_SOLID;
extern int                MainFiboWidth         = 1;
extern string             note3                 = "------------------------------";
extern bool               DisplayLowerFibo      = true;
extern color              LowerFiboColor        = clrCrimson; //clrDimGray
extern ENUM_LINE_STYLE    LowerFiboStyle        = STYLE_DASHDOTDOT;
extern int                LowerFiboWidth        = 1;

//Forex-Station button template start41; copy and paste
extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow         = 0;                               // What window to put the button on.  If <0, the button will use the same sub-window as the indicator.
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER;               // button corner on chart for anchoring
extern string             btn_text              = "FiboHOURS4";                     // a button name
extern string             btn_Font              = "Arial";                         // button font name
extern int                btn_FontSize          = 9;                               // button font size               
extern color              btn_text_ON_color     = clrLime;                         // ON color when the button is turned on
extern color              btn_text_OFF_color    = C'150,150,150';                          // OFF color when the button is turned off
extern color              btn_background_color  = C'50,50,50';                      // background color of the button
extern color              btn_border_color      = C'100,100,100';                        // border color the button
extern int                button_x              = 20;                              // x coordinate of the button     
extern int                button_y              = 45;                              // y coordinate of the button     
extern int                btn_Width             = 80;                              // button width
extern int                btn_Height            = 20;                              // button height
extern string             UniqueButtonID        = "SpudFiboHOURS42023";             // Unique ID for each button        
extern string             button_note2          = "------------------------------";
bool show_data, recalc=false;
string IndicatorObjPrefix, buttonId;
//Forex-Station button template end41; copy and paste

double HiPrice, LoPrice, Range;
datetime StartTime;
//+------------------------------------------------------------------------------------------------------------------+
//Forex-Station button template start42; copy and paste
int OnInit()
{
   IndicatorDigits(Digits);
   IndicatorObjPrefix = "_" + btn_text + "_";
      
   // The leading "_" gives buttonId a *unique* prefix.  Furthermore, prepending the swin is usually unique unless >2+ of THIS indy are displayed in the SAME sub-window. (But, if >2 used, be sure to shift the buttonId position)
   buttonId = "_" + UniqueButtonID + IndicatorObjPrefix + "_BT_";
   if (ObjectFind(buttonId)<0) 
      createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);

   show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
   mystart();
   DrawFibo();
  
   if (show_data) ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
   else ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width2,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width2);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
      // Upon creation, set the initial state to "true" which is "on", so one will see the indicator by default
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, true);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason) 
{
   // If just changing a TF', the button need not be deleted, therefore the 'OBJPROP_STATE' is also preserved.
   if(reason != REASON_CHARTCHANGE) ObjectDelete(buttonId);
      ObjectDelete("FiboUpHOURS4");
      ObjectDelete("FiboDownHOURS4");
      ObjectDelete("FiboInHOURS4");
      ObjectDelete("GoldenFibo");      
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   // If another indy on the same chart has enabled events for create/delete/mouse-move, just skip this events up front because they aren't
   //    needed, AND in the worst case, this indy might cause MT4 to hang!!  Skipping the events seems to help, along with other (major) changes to the code below.
   if(id==CHARTEVENT_OBJECT_CREATE || id==CHARTEVENT_OBJECT_DELETE) return; // This appears to make this indy compatible with other programs that enabled CHART_EVENT_OBJECT_CREATE and/or CHART_EVENT_OBJECT_DELETE
   if(id==CHARTEVENT_MOUSE_MOVE    || id==CHARTEVENT_MOUSE_WHEEL)   return; // If this, or another program, enabled mouse-events, these are not needed below, so skip it unless actually needed. 

   if (id==CHARTEVENT_OBJECT_CLICK && sparam == buttonId)
   {
      show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
      
      if (show_data)
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
         // Is it a problem to call 'start()' ??  Possibly it makes no difference, but now calling "mystart()" instead of "start()"; and "start()" simply runs "mystart()", so should be same as before.
         recalc=true;
         mystart();
         DrawFibo();
      }
      else
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
         ObjectDelete("FiboUpHOURS4");
         ObjectDelete("FiboDownHOURS4");
         ObjectDelete("FiboInHOURS4");      
         ObjectDelete("GoldenFibo");      
      }
   }
}
//Forex-Station button template end42; copy and paste
//+------------------------------------------------------------------------------------------------------------------+
int DrawFibo()
{
	if(DisplayUpperFibo)
	{

	if(ObjectFind("FiboUpHOURS4") == -1)
		ObjectCreate("FiboUpHOURS4",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUpHOURS4",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUpHOURS4",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUpHOURS4",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUpHOURS4",OBJPROP_PRICE2,HiPrice);
   }
   ObjectSet("FiboUpHOURS4",OBJPROP_LEVELSTYLE,UpperFiboStyle);
   ObjectSet("FiboUpHOURS4",OBJPROP_LEVELWIDTH,UpperFiboWidth);
   ObjectSet("FiboUpHOURS4",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUpHOURS4",OBJPROP_FIBOLEVELS,15);
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+0,0.0);	   
	if (!DisplayMainFibo)
       ObjectSetFiboDescription("FiboUpHOURS4",0,"HOURS4 BEFORE HIGH (100.0%%) -  $%$"); 
   else    
       ObjectSetFiboDescription("FiboUpHOURS4",0,""); 

   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboUpHOURS4",1,"(FE123.6%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+2,0.382); 	ObjectSetFiboDescription("FiboUpHOURS4",2,"(FE138.2%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+3,0.500); 	ObjectSetFiboDescription("FiboUpHOURS4",3,"(FE150.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+4,0.618); 	ObjectSetFiboDescription("FiboUpHOURS4",4,"(FE161.8%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+5,0.764); 	ObjectSetFiboDescription("FiboUpHOURS4",5,"(FE176.4%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+6,1.000); 	ObjectSetFiboDescription("FiboUpHOURS4",6,"(FE200.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+7,1.236);  ObjectSetFiboDescription("FiboUpHOURS4",7,"(FE223.6%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+8,1.500);  ObjectSetFiboDescription("FiboUpHOURS4",8,"(FE250.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+9,1.618);	ObjectSetFiboDescription("FiboUpHOURS4",9,"(FE261.8%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+10,2.000);	ObjectSetFiboDescription("FiboUpHOURS4",10,"(FE300.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+11,2.500);	ObjectSetFiboDescription("FiboUpHOURS4",11,"(FE350.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+12,3.000);	ObjectSetFiboDescription("FiboUpHOURS4",12,"(FE400.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+13,3.500);	ObjectSetFiboDescription("FiboUpHOURS4",13,"(FE450.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_FIRSTLEVEL+14,4.000);	ObjectSetFiboDescription("FiboUpHOURS4",14,"(FE500.0%%) -  $%$"); 
   ObjectSet("FiboUpHOURS4",OBJPROP_RAY,true);
   ObjectSet("FiboUpHOURS4",OBJPROP_BACK,true);
}
   else
	   ObjectDelete("FiboUpHOURS4");
//~~~~~~~~~~~~~~~
	if(DisplayLowerFibo)
	{
	if(ObjectFind("FiboDownHOURS4") == -1)
		ObjectCreate("FiboDownHOURS4",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDownHOURS4",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDownHOURS4",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDownHOURS4",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDownHOURS4",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDownHOURS4",OBJPROP_LEVELSTYLE,LowerFiboStyle);
   ObjectSet("FiboDownHOURS4",OBJPROP_LEVELWIDTH,LowerFiboWidth);
   ObjectSet("FiboDownHOURS4",OBJPROP_LEVELCOLOR,LowerFiboColor);      
   ObjectSet("FiboDownHOURS4",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+0,0.0);	   
	if (!DisplayMainFibo)
       ObjectSetFiboDescription("FiboDownHour4",0,"HOURS4 BEFORE LOW (F0.0%%) -  $%$"); 
   else
       ObjectSetFiboDescription("FiboDownHour4",0,""); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+1,0.236); 	ObjectSetFiboDescription("FiboDownHOURS4",1,"(FE-23.6%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+2,0.382); 	ObjectSetFiboDescription("FiboDownHOURS4",2,"(FE-38.2%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+3,0.500); 	ObjectSetFiboDescription("FiboDownHOURS4",3,"(FE-50.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+4,0.618); 	ObjectSetFiboDescription("FiboDownHOURS4",4,"(FE-61.8%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+5,0.764); 	ObjectSetFiboDescription("FiboDownHOURS4",5,"(FE-76.4%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+6,1.000); 	ObjectSetFiboDescription("FiboDownHOURS4",6,"(FE-100.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+7,1.236); 	ObjectSetFiboDescription("FiboDownHOURS4",7,"(FE-123.6%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+8,1.382);	ObjectSetFiboDescription("FiboDownHOURS4",8,"(FE-138.2%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+9,1.500); 	ObjectSetFiboDescription("FiboDownHOURS4",9,"(FE-150.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+10,1.618);	ObjectSetFiboDescription("FiboDownHOURS4",10,"(FE-161.8%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+11,1.764);	ObjectSetFiboDescription("FiboDownHOURS4",11,"(FE-176.4%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+12,2.000);	ObjectSetFiboDescription("FiboDownHOURS4",12,"(FE-200.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+13,2.500);	ObjectSetFiboDescription("FiboDownHOURS4",13,"(FE-250.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+14,3.000);	ObjectSetFiboDescription("FiboDownHOURS4",14,"(FE-300.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+15,3.500);	ObjectSetFiboDescription("FiboDownHOURS4",15,"(FE-350.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+16,4.000);	ObjectSetFiboDescription("FiboDownHOURS4",16,"(FE-400.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+17,4.500);	ObjectSetFiboDescription("FiboDownHOURS4",17,"(FE-450.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_FIRSTLEVEL+18,5.000);	ObjectSetFiboDescription("FiboDownHOURS4",18,"(FE-500.0%%) -  $%$"); 
   ObjectSet("FiboDownHOURS4",OBJPROP_RAY,true);
   ObjectSet("FiboDownHOURS4",OBJPROP_BACK,true);
}
   else
	   ObjectDelete("FiboDownHOURS4");
//~~~~~~~~~~~
	if(DisplayMainFibo)
	{
		if(ObjectFind("FiboInHOURS4") == -1)
			ObjectCreate("FiboInHOURS4",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_H4*60,LoPrice);
		else
		{
			ObjectSet("FiboInHOURS4",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboInHOURS4",OBJPROP_TIME1, StartTime+PERIOD_H4*60);
			ObjectSet("FiboInHOURS4",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboInHOURS4",OBJPROP_PRICE2,LoPrice);
		}
      ObjectSet("FiboInHOURS4",OBJPROP_LEVELSTYLE,MainFiboStyle);
      ObjectSet("FiboInHOURS4",OBJPROP_LEVELWIDTH,MainFiboWidth);
   	ObjectSet("FiboInHOURS4",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboInHOURS4",OBJPROP_FIBOLEVELS,5);
   	ObjectSet("FiboInHOURS4",OBJPROP_FIRSTLEVEL+0,0.0);	   ObjectSetFiboDescription("FiboInHOURS4",0,"HOURS4 BEFORE LOW (F0.0%%) -  $%$"); 
   	ObjectSet("FiboInHOURS4",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboInHOURS4",1,"(F23.6%%) -  $%$"); 
   	ObjectSet("FiboInHOURS4",OBJPROP_FIRSTLEVEL+2,0.500);	ObjectSetFiboDescription("FiboInHOURS4",2,"(F50.0%%) -  $%$"); 
   	ObjectSet("FiboInHOURS4",OBJPROP_FIRSTLEVEL+3,0.764);	ObjectSetFiboDescription("FiboInHOURS4",3,"(F76.4%%) -  $%$"); 
   	ObjectSet("FiboInHOURS4",OBJPROP_FIRSTLEVEL+4,1.000);	ObjectSetFiboDescription("FiboInHOURS4",4,"HOURS4 BEFORE HIGH (100.0%%) -  $%$"); 
   	ObjectSet("FiboInHOURS4",OBJPROP_RAY,true);
   	ObjectSet("FiboInHOURS4",OBJPROP_BACK,true);

		if(ObjectFind("GoldenFibo") == -1)
			ObjectCreate("GoldenFibo",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_H4*60,LoPrice);
		else
		{
			ObjectSet("GoldenFibo",OBJPROP_TIME2, StartTime);
			ObjectSet("GoldenFibo",OBJPROP_TIME1, StartTime+PERIOD_H4*60);
			ObjectSet("GoldenFibo",OBJPROP_PRICE1,HiPrice);
			ObjectSet("GoldenFibo",OBJPROP_PRICE2,LoPrice);
		}
      ObjectSet("GoldenFibo",OBJPROP_LEVELSTYLE,MainFiboStyle);
      ObjectSet("GoldenFibo",OBJPROP_LEVELWIDTH,MainFiboWidth);
   	ObjectSet("GoldenFibo",OBJPROP_LEVELCOLOR,GoldenFiboColor); 
   	ObjectSet("GoldenFibo",OBJPROP_FIBOLEVELS,2);
   	ObjectSet("GoldenFibo",OBJPROP_FIRSTLEVEL+0,0.382);	ObjectSetFiboDescription("GoldenFibo",0,"(F38.2%%) -  $%$"); 
     	ObjectSet("GoldenFibo",OBJPROP_FIRSTLEVEL+1,0.618);	ObjectSetFiboDescription("GoldenFibo",1,"(F61.8%%) -  $%$"); 
   	ObjectSet("GoldenFibo",OBJPROP_RAY,true);
   	ObjectSet("GoldenFibo",OBJPROP_BACK,true);
   }
   else
      {
	     ObjectDelete("FiboInHOURS4");
	     ObjectDelete("GoldenFibo");	     
	   }
	return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
int start() {return(mystart()); }
//+------------------------------------------------------------------------------------------------------------------+
int mystart()
  {
   if (show_data)
      {
        if(recalc) 
        {
           // If a button goes from off-to-on, everything must be recalculated.  The 'recalc' variable is used as a trigger to do this.
           recalc=false;
        }
	     int banzai	= iBarShift(NULL,PERIOD_H4,Time[0]) + 1;	// yesterday
	     HiPrice		= iHigh(NULL,PERIOD_H4,banzai);
	     LoPrice		= iLow (NULL,PERIOD_H4,banzai);
	     StartTime    = iTime(NULL,PERIOD_H4,banzai);

	     if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	     {//Add fridays high and low
		     HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_H4,banzai+1));
		     LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_H4,banzai+1));
	     } //	   if(TimeDayOfWeek(StartTime)==0/*Sunday*/)

	     Range = HiPrice-LoPrice;   
      } //if (show_data)  
   return(0);
}
//+------------------------------------------------------------------+
