// https://forex-station.com/viewtopic.php?p=1295478806#p1295478806 //button code1
// https://forex-station.com/viewtopic.php?p=1295478883#p1295478883 //button code2
// not for sale, rent, nor auction
// July 26th, 2020
// May 27th, 2023, v. 1.05; adding Golden Fibo color
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Define the Variables to use.....                                 |
//+------------------------------------------------------------------+
extern string             note1                 = "Fibonacci colors";
extern bool               DisplayUpperFibo      = true;
extern color              UpperFiboColor        = clrDarkOliveGreen; 
extern ENUM_LINE_STYLE    UpperFiboStyle        = STYLE_DASH;
extern int                UpperFiboWidth        = 1;
extern string             note2                 = "------------------------------";
extern bool               DisplayMainFibo       = true;
extern color              MainFiboColor         = clrOlive;
extern color              GoldenFiboColor       = clrDarkGoldenrod;
extern ENUM_LINE_STYLE    MainFiboStyle         = STYLE_SOLID;
extern int                MainFiboWidth         = 1;
extern string             note3                 = "------------------------------";
extern bool               DisplayLowerFibo      = true;
extern color              LowerFiboColor        = clrFireBrick; 
extern ENUM_LINE_STYLE    LowerFiboStyle        = STYLE_DASHDOTDOT;
extern int                LowerFiboWidth        = 1;

//Forex-Station button template start41; copy and paste
extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow         = 0;                               // What window to put the button on.  If <0, the button will use the same sub-window as the indicator.
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER;               // button corner on chart for anchoring
extern string             btn_text              = "FiboWeek";                      // a button name
extern string             btn_Font              = "Arial";                         // button font name
extern int                btn_FontSize          = 9;                               // button font size               
extern color              btn_text_ON_color     = clrLime;                         // ON color when the button is turned on
extern color              btn_text_OFF_color    = C'150,150,150';                          // OFF color when the button is turned off
extern color              btn_background_color  = C'50,50,50';                      // background color of the button
extern color              btn_border_color      = C'100,100,100';                        // border color the button
extern int                button_x              = 20;                              // x coordinate of the button     
extern int                button_y              = 45;                              // y coordinate of the button     
extern int                btn_Width             = 80;                              // button width
extern int                btn_Height            = 20;                              // button height
extern string             UniqueButtonID        = "SpudFiboWeekly2023";            // Unique ID for each button        
extern string             button_note2          = "------------------------------";
bool show_data, recalc=false;
string IndicatorObjPrefix, buttonId;
//Forex-Station button template end41; copy and paste

double HiPrice, LoPrice, Range;
datetime StartTime;
//+------------------------------------------------------------------------------------------------------------------+
//Forex-Station button template start42; copy and paste
int OnInit()
{
   IndicatorDigits(Digits);
   IndicatorObjPrefix = "_" + btn_text + "_";
      
   // The leading "_" gives buttonId a *unique* prefix.  Furthermore, prepending the swin is usually unique unless >2+ of THIS indy are displayed in the SAME sub-window. (But, if >2 used, be sure to shift the buttonId position)
   buttonId = "_" + UniqueButtonID + IndicatorObjPrefix + "_BT_";
   if (ObjectFind(buttonId)<0) 
      createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);

   show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
   mystart();
   DrawFibo();
  
   if (show_data) ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
   else ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width2,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width2);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
      // Upon creation, set the initial state to "true" which is "on", so one will see the indicator by default
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, true);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason) 
{
   // If just changing a TF', the button need not be deleted, therefore the 'OBJPROP_STATE' is also preserved.
   if(reason != REASON_CHARTCHANGE) ObjectDelete(buttonId);
      ObjectDelete("FiboUpWeekly");
      ObjectDelete("FiboDownWeekly");
      ObjectDelete("FiboInWeekly");
      ObjectDelete("GoldenFiboWeekly");      
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   // If another indy on the same chart has enabled events for create/delete/mouse-move, just skip this events up front because they aren't
   //    needed, AND in the worst case, this indy might cause MT4 to hang!!  Skipping the events seems to help, along with other (major) changes to the code below.
   if(id==CHARTEVENT_OBJECT_CREATE || id==CHARTEVENT_OBJECT_DELETE) return; // This appears to make this indy compatible with other programs that enabled CHART_EVENT_OBJECT_CREATE and/or CHART_EVENT_OBJECT_DELETE
   if(id==CHARTEVENT_MOUSE_MOVE    || id==CHARTEVENT_MOUSE_WHEEL)   return; // If this, or another program, enabled mouse-events, these are not needed below, so skip it unless actually needed. 

   if (id==CHARTEVENT_OBJECT_CLICK && sparam == buttonId)
   {
      show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
      
      if (show_data)
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
         // Is it a problem to call 'start()' ??  Possibly it makes no difference, but now calling "mystart()" instead of "start()"; and "start()" simply runs "mystart()", so should be same as before.
         recalc=true;
         mystart();
         DrawFibo();
      }
      else
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
         ObjectDelete("FiboUpWeekly");
         ObjectDelete("FiboDownWeekly");
         ObjectDelete("FiboInWeekly");      
         ObjectDelete("GoldenFiboWeekly");      
      }
   }
}
//Forex-Station button template end42; copy and paste
//+------------------------------------------------------------------------------------------------------------------+
int DrawFibo()
{
	if(DisplayUpperFibo)
	{

	if(ObjectFind("FiboUpWeekly") == -1)
		ObjectCreate("FiboUpWeekly",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUpWeekly",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUpWeekly",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUpWeekly",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUpWeekly",OBJPROP_PRICE2,HiPrice);
   }
   ObjectSet("FiboUpWeekly",OBJPROP_LEVELSTYLE,UpperFiboStyle);
   ObjectSet("FiboUpWeekly",OBJPROP_LEVELWIDTH,UpperFiboWidth);
   ObjectSet("FiboUpWeekly",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUpWeekly",OBJPROP_FIBOLEVELS,15);
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+0,0.0);	   
	if (!DisplayMainFibo)
       ObjectSetFiboDescription("FiboUpWeekly",0,"Last Week HIGH (100.0%%) -  $%$"); 
   else    
       ObjectSetFiboDescription("FiboUpWeekly",0,""); 

   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboUpWeekly",1,"(FE123.6%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+2,0.382); 	ObjectSetFiboDescription("FiboUpWeekly",2,"(FE138.2%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+3,0.500); 	ObjectSetFiboDescription("FiboUpWeekly",3,"(FE150.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+4,0.618); 	ObjectSetFiboDescription("FiboUpWeekly",4,"(FE161.8%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+5,0.764); 	ObjectSetFiboDescription("FiboUpWeekly",5,"(FE176.4%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+6,1.000); 	ObjectSetFiboDescription("FiboUpWeekly",6,"(FE200.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+7,1.236);  ObjectSetFiboDescription("FiboUpWeekly",7,"(FE223.6%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+8,1.500);  ObjectSetFiboDescription("FiboUpWeekly",8,"(FE250.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+9,1.618);	ObjectSetFiboDescription("FiboUpWeekly",9,"(FE261.8%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+10,2.000);	ObjectSetFiboDescription("FiboUpWeekly",10,"(FE300.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+11,2.500);	ObjectSetFiboDescription("FiboUpWeekly",11,"(FE350.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+12,3.000);	ObjectSetFiboDescription("FiboUpWeekly",12,"(FE400.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+13,3.500);	ObjectSetFiboDescription("FiboUpWeekly",13,"(FE450.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+14,4.000);	ObjectSetFiboDescription("FiboUpWeekly",14,"(FE500.0%%) -  $%$"); 
   ObjectSet("FiboUpWeekly",OBJPROP_RAY,true);
   ObjectSet("FiboUpWeekly",OBJPROP_BACK,true);
}
   else
	   ObjectDelete("FiboUpWeekly");
//~~~~~~~~~~~~~~~
	if(DisplayLowerFibo)
	{
	if(ObjectFind("FiboDownWeekly") == -1)
		ObjectCreate("FiboDownWeekly",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDownWeekly",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDownWeekly",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDownWeekly",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDownWeekly",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDownWeekly",OBJPROP_LEVELSTYLE,LowerFiboStyle);
   ObjectSet("FiboDownWeekly",OBJPROP_LEVELWIDTH,LowerFiboWidth);
   ObjectSet("FiboDownWeekly",OBJPROP_LEVELCOLOR,LowerFiboColor);      
   ObjectSet("FiboDownWeekly",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+0,0.0);	   
	if (!DisplayMainFibo)
       ObjectSetFiboDescription("FiboDownWeekly",0,"Last Week LOW (F0.0%%) -  $%$"); 
   else
       ObjectSetFiboDescription("FiboDownWeekly",0,""); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+1,0.236); 	ObjectSetFiboDescription("FiboDownWeekly",1,"(FE-23.6%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+2,0.382); 	ObjectSetFiboDescription("FiboDownWeekly",2,"(FE-38.2%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+3,0.500); 	ObjectSetFiboDescription("FiboDownWeekly",3,"(FE-50.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+4,0.618); 	ObjectSetFiboDescription("FiboDownWeekly",4,"(FE-61.8%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+5,0.764); 	ObjectSetFiboDescription("FiboDownWeekly",5,"(FE-76.4%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+6,1.000);  	ObjectSetFiboDescription("FiboDownWeekly",6,"(FE-100.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+7,1.236); 	ObjectSetFiboDescription("FiboDownWeekly",7,"(FE-123.6%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+8,1.382);	ObjectSetFiboDescription("FiboDownWeekly",8,"(FE-138.2%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+9,1.500); 	ObjectSetFiboDescription("FiboDownWeekly",9,"(FE-150.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+10,1.618);	ObjectSetFiboDescription("FiboDownWeekly",10,"(FE-161.8%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+11,1.764);	ObjectSetFiboDescription("FiboDownWeekly",11,"(FE-176.4%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+12,2.000);	ObjectSetFiboDescription("FiboDownWeekly",12,"(FE-200.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+13,2.500);	ObjectSetFiboDescription("FiboDownWeekly",13,"(FE-250.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+14,3.000);	ObjectSetFiboDescription("FiboDownWeekly",14,"(FE-300.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+15,3.500);	ObjectSetFiboDescription("FiboDownWeekly",15,"(FE-350.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+16,4.000);	ObjectSetFiboDescription("FiboDownWeekly",16,"(FE-400.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+17,4.500);	ObjectSetFiboDescription("FiboDownWeekly",17,"(FE-450.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+18,5.000);	ObjectSetFiboDescription("FiboDownWeekly",18,"(FE-500.0%%) -  $%$"); 
   ObjectSet("FiboDownWeekly",OBJPROP_RAY,true);
   ObjectSet("FiboDownWeekly",OBJPROP_BACK,true);
}
   else
	   ObjectDelete("FiboDownWeekly");
//~~~~~~~~~~~
	if(DisplayMainFibo)
	{
		if(ObjectFind("FiboInWeekly") == -1)
			ObjectCreate("FiboInWeekly",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
		else
		{
			ObjectSet("FiboInWeekly",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboInWeekly",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
			ObjectSet("FiboInWeekly",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboInWeekly",OBJPROP_PRICE2,LoPrice);
		}
      ObjectSet("FiboInWeekly",OBJPROP_LEVELSTYLE,MainFiboStyle);
      ObjectSet("FiboInWeekly",OBJPROP_LEVELWIDTH,MainFiboWidth);
   	ObjectSet("FiboInWeekly",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIBOLEVELS,5);
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+0,0.0);	   ObjectSetFiboDescription("FiboInWeekly",0,"Last Week LOW (F0.0%%) -  $%$"); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboInWeekly",1,"(F23.6%%) -  $%$"); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+2,0.500);	ObjectSetFiboDescription("FiboInWeekly",2,"(F50.0%%) -  $%$"); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+3,0.764);	ObjectSetFiboDescription("FiboInWeekly",3,"(F76.4%%) -  $%$"); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+4,1.000);	ObjectSetFiboDescription("FiboInWeekly",4,"Last Week HIGH (100.0%%) -  $%$"); 
   	ObjectSet("FiboInWeekly",OBJPROP_RAY,true);
   	ObjectSet("FiboInWeekly",OBJPROP_BACK,true);

		if(ObjectFind("GoldenFiboWeekly") == -1)
			ObjectCreate("GoldenFiboWeekly",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
		else
		{
			ObjectSet("GoldenFiboWeekly",OBJPROP_TIME2, StartTime);
			ObjectSet("GoldenFiboWeekly",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
			ObjectSet("GoldenFiboWeekly",OBJPROP_PRICE1,HiPrice);
			ObjectSet("GoldenFiboWeekly",OBJPROP_PRICE2,LoPrice);
		}
      ObjectSet("GoldenFiboWeekly",OBJPROP_LEVELSTYLE,MainFiboStyle);
      ObjectSet("GoldenFiboWeekly",OBJPROP_LEVELWIDTH,MainFiboWidth);
   	ObjectSet("GoldenFiboWeekly",OBJPROP_LEVELCOLOR,GoldenFiboColor); 
   	ObjectSet("GoldenFiboWeekly",OBJPROP_FIBOLEVELS,2);
   	ObjectSet("GoldenFiboWeekly",OBJPROP_FIRSTLEVEL+0,0.382);	ObjectSetFiboDescription("GoldenFiboWeekly",0,"(F38.2%%) -  $%$"); 
     	ObjectSet("GoldenFiboWeekly",OBJPROP_FIRSTLEVEL+1,0.618);	ObjectSetFiboDescription("GoldenFiboWeekly",1,"(F61.8%%) -  $%$"); 
   	ObjectSet("GoldenFiboWeekly",OBJPROP_RAY,true);
   	ObjectSet("GoldenFiboWeekly",OBJPROP_BACK,true);
   }
   else
      {
	     ObjectDelete("FiboInWeekly");
	     ObjectDelete("GoldenFiboWeekly");	     
	   }
	return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
int start() {return(mystart()); }
//+------------------------------------------------------------------------------------------------------------------+
int mystart()
  {
   if (show_data)
      {
        if(recalc) 
        {
           // If a button goes from off-to-on, everything must be recalculated.  The 'recalc' variable is used as a trigger to do this.
           recalc=false;
        }
	     int banzai	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	// yesterday
	     HiPrice		= iHigh(NULL,PERIOD_W1,banzai);
	     LoPrice		= iLow (NULL,PERIOD_W1,banzai);
	     StartTime    = iTime(NULL,PERIOD_W1,banzai);

	     if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	     {//Add fridays high and low
		     HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_W1,banzai+1));
		     LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_W1,banzai+1));
	     } //	   if(TimeDayOfWeek(StartTime)==0/*Sunday*/)

	     Range = HiPrice-LoPrice;   
      } //if (show_data)  
   return(0);
}
//+------------------------------------------------------------------+
